// ChildView.cpp : implementation of the CChildView class
// WELL DONE ON MULTIPLE SELECTION!!!!

#include "stdafx.h"
#include "OpenGLApp.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

static const GLfloat lightAmbient[] = { 1, 1, 1, 1 };
static const GLfloat lightDiffuse[] = { 1, 1, 1, 1 };
static const GLfloat lightPosition[] = { 75, 75, 75 };

CChildView::CChildView()
{
	m_fXPos = 0.0f;
	m_fYPos = 0.0f;
	m_fXAngle = 0.0f;
	m_fYAngle = 0.0f;

	// SPECIFIC
	m_iMapSizeX = 10;
	m_iMapSizeY = 10;
	m_iTileSizeX = 2;
	m_iTileSizeY = 2;
	m_pMap = NULL;
	m_iLastID = 1;
	m_iSelectedItem = 1;
	m_iPickedObject = -1;
	strcpy(m_strSaveFile, "default.scn");
	m_bConstPick = false;
	// 0 - Items, 1 - Walls, 2 - Enemies, 3 - Effects, 4 - Other
	/*
	m_strMdlAssoc = new char**[5]; // 5 together of the above
	
	m_strMdlAssoc[0] = new char *[m_numTemplateItems];
	for (i =0; i<m_numTemplateItems; i++)
		m_strMdlAssoc[0][i] = new char[255];

	m_strMdlAssoc[1] = new char *[m_numTemplateWalls];
	for (i =0; i<m_numTemplateWalls; i++)
		m_strMdlAssoc[1][i] = new char[255];

	m_strMdlAssoc[2] = new char *[m_numTemplateEnemies];
	for (i =0; i<m_numTemplateEnemies; i++)
		m_strMdlAssoc[2][i] = new char[255];

	m_strMdlAssoc[3] = new char *[m_numTemplateEffects];
	for (i =0; i<m_numTemplateEffects; i++)
		m_strMdlAssoc[3][i] = new char[255];

	m_strMdlAssoc[4] = new char *[m_numTemplateMisc];
	for (i =0; i<m_numTemplateMisc; i++)
		m_strMdlAssoc[4][i] = new char[255];

	*/
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )

	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KILLFOCUS()

	//{{AFX_MSG_MAP(CChildView)
	ON_COMMAND(ID_FILE_NEWSCENE, OnNewScene)
	ON_COMMAND(ID_FILE_SAVESCENE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_RESETSCENE, OnFileResetscene)
	ON_COMMAND(ID_FILE_LOADSCENE, OnFileLoad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

//	cs.dwExStyle |= WS_EX_CLIENTEDGE;
//	cs.style &= ~WS_BORDER;
//	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
//	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKSW, NULL,
//		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView message handlers

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//Initialize OpenGL Here
	InitializeOpenGL();

	m_DlgChooseTile.Create(IDD_CHOOSETILE, this);
	m_DlgChooseTile.pParent = this;
	m_DlgMapProp.Create(IDD_MAPPROP, this);
	m_DlgMapProp.pParent = this;
	m_DlgMapProp.ShowWindow(SW_SHOW);


	m_DlgMapProp.ShowWindow(SW_SHOW);
	m_DlgChooseTile.ShowWindow(SW_SHOW);

	LoadScene("default.scn");
	return 0;
}

BOOL CChildView::OnEraseBkgnd(CDC* pDC) 
{
	
	//comment out the original call
	//return CView::OnEraseBkgnd(pDC);
	//Tell Windows not to erase the background
	return TRUE;
}

void CChildView::OnSize(UINT nType, int cx, int cy) 
{
//	CWnd::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	GLdouble aspect_ratio; // width/height ratio
	
	if ( 0 >= cx || 0 >= cy )
	{
		return;
	}

	// select the full client area
    glViewport(0, 0, cx, cy);

	// compute the aspect ratio
	// this will keep all dimension scales equal
	aspect_ratio = (GLdouble)cx/(GLdouble)cy;

	// select the projection matrix and clear it
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

	// select the viewing volume
	gluPerspective(45.0f, aspect_ratio, .01f, 200.0f);
	
	// switch back to the modelview matrix and clear it
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

void CChildView::OnDestroy() 
{
//	CWnd::OnDestroy();
	
	// TODO: Add your message handler code here
	//Make the RC non-current
	if(::wglMakeCurrent (0,0) == FALSE)
	{
		MessageBox("Could not make RC non-current");
	}
	
	//Delete the rendering context
	if(::wglDeleteContext (m_hRC) == FALSE)
	{
		MessageBox("Could not delete RC");
	}
	
	//Delete the DC
	if(m_pDC !=NULL)
	{
		delete m_pDC;
		m_pDC = NULL;
	}

	DestroyScene();

	m_DlgChooseTile.DestroyWindow();
	m_DlgMapProp.DestroyWindow();

}

BOOL CChildView::InitializeOpenGL()
{
	//Get a DC for the Client Area
	m_pDC = new CClientDC(this);

	//Failure to Get DC
	if(m_pDC == NULL)
	{
		MessageBox("Error Obtaining DC");
		return FALSE;
	}

	//Failure to set the pixel format
	if(!SetupPixelFormat())
	{
		return FALSE;
	}

	//Create Rendering Context
	m_hRC = ::wglCreateContext (m_pDC->GetSafeHdc ());

	//Failure to Create Rendering Context
	if(m_hRC == 0)
	{
		MessageBox("Error Creating RC");
		return FALSE;
	}
	
	//Make the RC Current
	if(::wglMakeCurrent (m_pDC->GetSafeHdc (), m_hRC)==FALSE)
	{
		MessageBox("Error making RC Current");
		return FALSE;
	}

	//Specify Black as the clear color
	glClearColor(0.0f,0.0f,0.0f,0.0f);

	//Specify the back of the buffer as clear depth
	glClearDepth(1.0f);

	//Enable Depth Testing
	glEnable(GL_DEPTH_TEST);

	m_TemplateTile.m_pVertices = new tBoneVertex[4];
	m_TemplateTile.m_iNumVertices = 4;
	m_TemplateTile.m_pVertices[0] = CVector(0, 0, 0);
	m_TemplateTile.m_pVertices[1] = CVector(m_iTileSizeX, 0, 0);
	m_TemplateTile.m_pVertices[2] = CVector(m_iTileSizeX, m_iTileSizeY, 0);
	m_TemplateTile.m_pVertices[3] = CVector(0, m_iTileSizeY, 0);
	m_TemplateTile.m_pTriangles = new tTriangle[2];
	m_TemplateTile.m_pTriangles[0].m_vertexIndices[0] = 0;
	m_TemplateTile.m_pTriangles[0].m_vertexIndices[1] = 1;
	m_TemplateTile.m_pTriangles[0].m_vertexIndices[2] = 2;
			
	m_TemplateTile.m_pTriangles[1].m_vertexIndices[0] = 3;
	m_TemplateTile.m_pTriangles[1].m_vertexIndices[1] = 0;
	m_TemplateTile.m_pTriangles[1].m_vertexIndices[2] = 2;

	m_TemplateTile.m_iNumTriangles = 2;
	m_TemplateTile.m_iNumMeshes = 1;
	m_TemplateTile.m_pMeshes = new tMesh;
			
	m_TemplateTile.m_pMeshes[0].m_numTriangles = 2;
	m_TemplateTile.m_pMeshes[0].m_pTriangleIndices = new int[2];
	m_TemplateTile.m_pMeshes[0].m_pTriangleIndices[0] = 0;
	m_TemplateTile.m_pMeshes[0].m_pTriangleIndices[1] = 1;

	// First triangle mappings
	m_TemplateTile.m_pTriangles[0].m_s[0] = 0.0; 
	m_TemplateTile.m_pTriangles[0].m_t[0] = 1.0;
	m_TemplateTile.m_pTriangles[0].m_s[1] = 1.0; 
	m_TemplateTile.m_pTriangles[0].m_t[1] = 1.0;
	m_TemplateTile.m_pTriangles[0].m_s[2] = 1.0; 
	m_TemplateTile.m_pTriangles[0].m_t[2] = 0.0;

	// First triangle mappings
	m_TemplateTile.m_pTriangles[1].m_s[0] = 0.0; 
	m_TemplateTile.m_pTriangles[1].m_t[0] = 0.0;
	m_TemplateTile.m_pTriangles[1].m_s[1] = 0.0; 
	m_TemplateTile.m_pTriangles[1].m_t[1] = 1.0;
	m_TemplateTile.m_pTriangles[1].m_s[2] = 1.0; 
	m_TemplateTile.m_pTriangles[1].m_t[2] = 0.0;
	
	//glEnable(GL_LIGHTING);								// Enable Lighting
	//glEnable(GL_LIGHT1);								// Enable Light Number #1
	//glLightfv( GL_LIGHT1, GL_AMBIENT_AND_DIFFUSE, lightDiffuse );
	//glLightfv( GL_LIGHT1, GL_DIFFUSE, lightDiffuse );
	glEnable(GL_LIGHTING);								// Enable Lighting
	glEnable(GL_LIGHT1);								// Enable Light Number #1
	glLightfv( GL_LIGHT1, GL_AMBIENT_AND_DIFFUSE, lightDiffuse );
	glLightfv( GL_LIGHT1, GL_DIFFUSE, lightDiffuse );
	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping ( NEW )
	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculation

	return TRUE;
}

//Setup Pixel Format
/////////////////////////////////////////////////////////////////////////////
BOOL CChildView::SetupPixelFormat()
{
  static PIXELFORMATDESCRIPTOR pfd = 
	{
        sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
        1,                              // version number
        PFD_DRAW_TO_WINDOW |            // support window
        PFD_SUPPORT_OPENGL |		    // support OpenGL
        PFD_DOUBLEBUFFER,				// double buffered
        PFD_TYPE_RGBA,                  // RGBA type
        24,                             // 24-bit color depth
        0, 0, 0, 0, 0, 0,               // color bits ignored
        0,                              // no alpha buffer
        0,                              // shift bit ignored
        0,                              // no accumulation buffer
        0, 0, 0, 0,                     // accum bits ignored
        16,                             // 16-bit z-buffer
        0,                              // no stencil buffer
        0,                              // no auxiliary buffer
        PFD_MAIN_PLANE,                 // main layer
        0,                              // reserved
        0, 0, 0                         // layer masks ignored
    };
    
    int m_nPixelFormat = ::ChoosePixelFormat(m_pDC->GetSafeHdc(), &pfd);

	if ( m_nPixelFormat == 0 )
	{
       return FALSE;
	}

    if ( ::SetPixelFormat(m_pDC->GetSafeHdc(), m_nPixelFormat, &pfd) == FALSE)
    {
       return FALSE;
	}

    return TRUE;
}

void CChildView::RenderScene ()
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glLoadIdentity();

	glLightfv( GL_LIGHT1, GL_POSITION, lightPosition );
	glMultMatrixf(m_gViewMatrix.m_matrix);
	
	DrawTiles();
	
	SwapBuffers( m_pDC->GetSafeHdc() );
}

void CChildView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch (nChar)
	{
		case VK_UP:
			m_gViewMatrix.SetTranslation(CVector(m_gViewMatrix.m_matrix[12], m_gViewMatrix.m_matrix[13] + 0.1f,  m_gViewMatrix.m_matrix[14])); 
		break;

		case VK_DOWN:
			m_gViewMatrix.SetTranslation(CVector(m_gViewMatrix.m_matrix[12], m_gViewMatrix.m_matrix[13] - 0.1f,  m_gViewMatrix.m_matrix[14])); 
		break;

		case VK_LEFT:
			m_gViewMatrix.SetTranslation(CVector(m_gViewMatrix.m_matrix[12] - 0.1f, m_gViewMatrix.m_matrix[13],  m_gViewMatrix.m_matrix[14])); 
		break;

		case VK_RIGHT:
			m_gViewMatrix.SetTranslation(CVector(m_gViewMatrix.m_matrix[12] + 0.1f, m_gViewMatrix.m_matrix[13],  m_gViewMatrix.m_matrix[14])); 
		break;

		case 187:	// + zoom in
			m_gViewMatrix.SetTranslation(CVector(m_gViewMatrix.m_matrix[12], m_gViewMatrix.m_matrix[13],  m_gViewMatrix.m_matrix[14] + 0.1f)); 
		break;
		
		case 189:
			m_gViewMatrix.SetTranslation(CVector(m_gViewMatrix.m_matrix[12], m_gViewMatrix.m_matrix[13],  m_gViewMatrix.m_matrix[14] - 0.1f)); 
		break;
	}

	InvalidateRect(NULL,FALSE);
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_MouseDownPoint=point;
	PickObject(point.x, point.y); // PICK AN OBJECT FROM MOUSE POINT ON SCREEN
	SetCapture();
	m_bConstPick = true;	// WHEN WE MOVE MOUSE, THIS TELLS IF WE HOLD LEFT BUTTON
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_MouseDownPoint=CPoint(0,0);
	ReleaseCapture();
	m_bConstPick = false;	// WHEN WE MOVE MOUSE, THIS TELLS IF WE HOLD LEFT BUTTON
}

void CChildView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	GetCursorPos(&point);
    CMenu mnuTop;
    mnuTop.LoadMenu(IDR_POPUP_MENU);
    CMenu* pPopup = mnuTop.GetSubMenu(0);
    pPopup->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RIGHTBUTTON |
                           TPM_LEFTALIGN, point.x, point.y, AfxGetMainWnd(), NULL);
	
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Check if we have captured the mouse
	if (GetCapture()==this)
		m_MouseDownPoint=point;
}

bool CChildView::SaveScene(char *filename)
{
	if(filename == NULL)
		return false;

	FILE *file = fopen(filename, "w+t");

	if(file == NULL)
		return false;

	// WRITE HEADER FIRST
	fprintf(file, "%d %d %d %d %d\n", m_iMapSizeX, m_iMapSizeY,
												 m_iTileSizeX, m_iTileSizeY, m_iNumSceneTextures);
	// SAVE GLOBAL VIEW MATRIX
	SaveMatrix(&m_gViewMatrix, NULL, file);
	
	int i = 0;
	
	// SAVE ALL TEXTURES FILENAMES
	for (i=0; i<m_lstMaterials.size(); i++)
		fprintf(file, "%s\n", m_lstMaterials.at(i)->m_strFilename);
	
	// SAVE TILES
	for (int j=0; j<m_iMapSizeY; j++)
	{
		for (int i=0; i<m_iMapSizeX; i++)
			fprintf(file, "%d ", LOWORD(m_pMap[j][i].m_wReserved));	// TEXTURE INDEX FOR TILE
	}

	// CLOSE FILE
	fclose(file);

	// RETURN TRUE ON SUCCESS
	return true;
}

bool CChildView::LoadScene(char *filename)
{
		// MAKE SURE FILENAME ISN'T NOTHING
	if(filename == NULL)
		return false;

	FILE *file = fopen(filename, "r+t");

	// MAKE SURE THAT FILE DOES EXIST
	if(file == NULL)
		return false;

	DestroyScene(); // CLEAR UP CURRENT SCENE FIRST

	int mapsx, mapsy, tilesx, tilesy;

	// Read header
	fscanf(file, "%d %d %d %d %d\n", &mapsx, &mapsy,
												 &tilesx, &tilesy, &m_iNumSceneTextures);

	if(mapsx <=0 || mapsy <=0 || tilesx <=0 || tilesy <=0)
		return false;
	
	m_iMapSizeX = mapsx;
	m_iMapSizeY = mapsy;
	m_iTileSizeX = tilesx;
	m_iTileSizeY = tilesy;

	LoadMatrix(&m_gViewMatrix, NULL, file);

	CreateTiles();	

	// Read textures into global texture array
	char buf[255] = ""; // read buffer
	int i=0;

	for (i=0; i<m_iNumSceneTextures; i++)
	{

		tMaterial *tmp = new tMaterial; // NO RAW FILES, they are to be loaded later
		fscanf(file, "%s\n", buf);
		if(LoadTexture(buf, tmp, true))
			m_lstMaterials.push_back(tmp);
	}

	// TILES START
	// Allocate actual tile array
	int matid = -1;

	// Read Material ID for each tile
	for (i=0; i<m_iMapSizeY; i++)
	{
		for (int j=0; j<m_iMapSizeX; j++)
		{
			fscanf(file, "%d ", &matid);
			m_pMap[i][j].m_wReserved = MAKELONG(matid, 0);
		}
	}
	// TILES END

	int numitems = 0;
	
	fclose(file);
	return true; // RETURN TRUE ON SUCCESSEFUL LOADING OF A SCENE
}


void CChildView::DestroyScene()
{
	m_lstMaterials.erase();
	
	if(m_iMapSizeX > 0 && m_iMapSizeY > 0 && m_pMap !=NULL)
	{
		for (int y=0; y<m_iMapSizeY; y++)
			SAFEDEL(m_pMap[y]);

		SAFEDEL(m_pMap);
		m_pMap = NULL;
		m_iMapSizeX = m_iMapSizeY = 0;
	}

}

void CChildView::CreateTiles()
{
	// Default square

		m_pMap = new CTile*[m_iMapSizeY];
	for (int i=0; i<m_iMapSizeY; i++)
		m_pMap[i] = new CTile[m_iMapSizeX];

	for (int y=0; y<m_iMapSizeY; y++)
	{
		for (int x=0; x<m_iMapSizeX; x++)
		{

			m_pMap[y][x].m_ViewMatrix.SetTranslation(CVector(x*m_iTileSizeX, y*m_iTileSizeY, 0));
			
			m_pMap[y][x].m_wReserved = 1;
			AllocateID(&m_pMap[y][x]);
			strcpy(m_pMap[y][x].m_strName, "tile");
			m_pMap[y][x].m_eMaterialRender = TEX;
		}
	}
}

void CChildView::DrawTiles()
{
	if(m_pMap == NULL)
		return;

	for (int i=0; i<m_iMapSizeY; i++)
	{
		for (int j=0; j<m_iMapSizeX; j++)
		{
			if(m_iPickedObject>= 0 && m_pMap[i][j].m_ID == m_iPickedObject)
			{
				if(m_iSelectedItem >= 0)
					m_pMap[i][j].m_wReserved = MAKELONG(m_iSelectedItem, 0);
				//glDisable(GL_LIGHTING);
				glEnable(GL_BLEND);
			//	glDisable(GL_DEPTH_TEST);
				glColor4f(0.89f,0.75f,0.75f,0.75f);			// Full Brightness, 50% Alpha ( NEW )
				glBlendFunc(GL_SRC_ALPHA,GL_ONE);		// Blending Function For Translucency Based On Source Alpha Value ( NEW )
				
				if(LOWORD(m_pMap[i][j].m_wReserved) >= 0)
				{
				//	glEnable(GL_TEXTURE_2D);
					glBindTexture(GL_TEXTURE_2D, m_lstMaterials.at(LOWORD(m_pMap[i][j].m_wReserved))->m_id);
				}
				m_TemplateTile.m_ID = m_pMap[i][j].m_ID;
				m_TemplateTile.m_ViewMatrix = m_pMap[i][j].m_ViewMatrix;
				m_TemplateTile.Draw();	
				glDisable(GL_BLEND);
			}
			else
			{
				glColor3d(1,1,1);
				if(LOWORD(m_pMap[i][j].m_wReserved) >= 0)
					ApplyMaterial(m_lstMaterials.at(LOWORD(m_pMap[i][j].m_wReserved)), m_pMap[i][j].m_eMaterialRender, NULL);
				

				m_TemplateTile.m_ID = m_pMap[i][j].m_ID;
				m_TemplateTile.m_ViewMatrix = m_pMap[i][j].m_ViewMatrix;
				m_TemplateTile.Draw();	
			}
		}
	}
}


void CChildView::PickObject(int x, int y)
{
	GLuint	buffer[512];										// Set Up A Selection Buffer
	GLint	hits;												// The Number Of Objects That We Selected

	// The Size Of The Viewport. [0] Is <x>, [1] Is <y>, [2] Is <length>, [3] Is <width>
	GLint	viewport[4];

	// This Sets The Array <viewport> To The Size And Location Of The Screen Relative To The Window
	glGetIntegerv(GL_VIEWPORT, viewport);
	glSelectBuffer(512, buffer);								// Tell OpenGL To Use Our Array For Selection

	(void) glRenderMode(GL_SELECT);
	glInitNames();												// Initializes The Name Stack
	glPushName(0);												// Push 0 (At Least One Entry) Onto The Stack

	// Puts OpenGL In Selection Mode. Nothing Will Be Drawn.  Object ID's and Extents Are Stored In The Buffer.
	
	glMatrixMode(GL_PROJECTION);								// Selects The Projection Matrix
	glPushMatrix();												// Push The Projection Matrix
	glLoadIdentity();											// Resets The Matrix

	// This Creates A Matrix That Will Zoom Up To A Small Portion Of The Screen, Where The Mouse Is.
	gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3]-y), 1.0f, 1.0f, viewport);

	// Apply The Perspective Matrix
	gluPerspective(45.0f, (GLfloat) (viewport[2]-viewport[0])/(GLfloat) (viewport[3]-viewport[1]), 0.1f, 100.0f);
	
	/*  create 5x5 pixel picking region near cursor location */
//	gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y),
//               5.0, 5.0, viewport);

	glMatrixMode(GL_MODELVIEW);									// Select The Modelview Matrix
	
	// Draw everything
	DrawTiles();
				
	glMatrixMode(GL_PROJECTION);								// Select The Projection Matrix
	glPopMatrix();												// Pop The Projection Matrix
	glMatrixMode(GL_MODELVIEW);									// Select The Modelview Matrix
	
	hits = glRenderMode(GL_RENDER);								// Switch To Render Mode, Find Out How Many
	GLuint depth = 0;
	
	int choose = -1;
	if (hits > 0)// If There Were More Than 0 Hits
	{
		choose = buffer[3];// Make Our Selection The First Object
		int depth = buffer[1];// Store How Far Away It Is

		for (int loop = 1; loop < hits; loop++)// Loop Through All The Detected Hits
		{
			// If This Object Is Closer To Us Than The One We Have Selected
			if (buffer[loop*4+1] < GLuint(depth))
			{
				choose = buffer[loop*4+3];// Select The Closer Object
				depth = buffer[loop*4+1];// Store How Far Away It Is
			}       
		}
	}

	m_iPickedObject = choose;
}

void CChildView::AllocateID(CModel *mdl)
{
	if(mdl == NULL)
		return;

	m_iLastID++;
	mdl->m_ID = m_iLastID;
}



LRESULT CChildView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
switch(message)
	{
		// We are creating new map with diff size and tile sizes
		case MSG_CREATEMAP:
		{
			if(m_iMapSizeX > 0 && m_iMapSizeY > 0 && m_pMap !=NULL)
			{
				for (int y=0; y<m_iMapSizeY; y++)
					SAFEDEL(m_pMap[y]);

				SAFEDEL(m_pMap);
				m_pMap = NULL;
			}

			m_iMapSizeX = LOWORD(wParam);	m_iTileSizeX = (float)LOWORD(lParam)/5.0;
			m_iMapSizeY = HIWORD(wParam);	m_iTileSizeY = (float)HIWORD(lParam)/5.0;
			CreateTiles();
		}
		break;

		// Tile has been selected
		case MSG_SELTILE:
			m_iSelectedItem = LOWORD(wParam);
			m_iSelectedSet = HIWORD(wParam);
			if(m_iSelectedItem == 65535)
				m_iSelectedItem = 1;
		break;
	}

	return CWnd ::WindowProc(message, wParam, lParam);
}


void CChildView::OnKillFocus(CWnd* pNewWnd) 
{
	m_iPickedObject = -1;
}

void CChildView::OnNewScene() 
{
	m_DlgMapProp.ShowWindow(SW_SHOW);
}

void CChildView::OnFileResetscene() 
{
	DestroyScene();
}


void CChildView::OnFileSave() 
{
	SaveScene(m_strSaveFile);	
}


void CChildView::OnFileSaveAs() 
{
	CString strFilter = "All Files (*.*)|*.*||";

	CFileDialog saveas(FALSE, NULL, NULL,
						OFN_CREATEPROMPT | OFN_OVERWRITEPROMPT,
						strFilter, NULL);

	if(saveas.DoModal() == IDOK)
		SaveScene((saveas.GetPathName()).GetBuffer(255));
}

void CChildView::OnFileLoad() 
{
	CFileDialog loadscene(TRUE, NULL, NULL,
						OFN_CREATEPROMPT | OFN_OVERWRITEPROMPT,
						NULL,NULL);
	
	if(loadscene.DoModal() == IDOK)
		LoadScene((loadscene.GetPathName()).GetBuffer(255));
}

