// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__47020E0B_A6BF_4DC6_81A5_BBEB3415FFE9__INCLUDED_)
#define AFX_CHILDVIEW_H__47020E0B_A6BF_4DC6_81A5_BBEB3415FFE9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CChildView window
#ifdef _WIN32
# pragma warning(disable:4786) // We know basic_string generates long names :-)
#endif

#include "Tile.h"

#include <string>
#include <map>
using namespace std;

// DIALOGS
#include "ChooseTile.h"
#include "MapProp.h"
#include "Material.h"
#include "Maths.h"
#include "DoubleList.h"
#include "Milkshape.h"

// DIALOGS

class CChildView : public CWnd
{
// Construction
public:
	CChildView();

// Attributes
public:

	HGLRC m_hRC;	//Rendering Context
	CDC* m_pDC;		//Device Context

	bool m_bConstPick;
	float m_fXAngle;
	float m_fYAngle;
	float m_fXPos;
	float m_fYPos;
	float m_fZPos;

	CPoint m_MouseDownPoint;
	CMatrix	m_gViewMatrix;
	// MAP RELATED
	CTile **m_pMap;
	CTile m_TemplateTile;
	int m_iMapSizeX, m_iMapSizeY, 
		m_iTileSizeX, m_iTileSizeY, m_iNumSceneTextures;
	// MAP RELATED

	CDoubleList <tMaterial *> m_lstMaterials;
	unsigned int m_iLastID;

	// PICKING VARIABLES
	int m_iPickedObject;
	int m_iTileTexture;
	
	int m_iSelectedItem, m_iSelectedSet;	// TEXTURES DIALOG RETURNED VARIABLES
	// PICKING VARIABLES
	
	int m_iFPS;
	// DIALOGS
	CChooseTile m_DlgChooseTile;
	CMapProp m_DlgMapProp;			// Create map dialog
	// DIALOGS

	// SAVE/LOAD
	char m_strSaveFile[1024];

// Operations
public:
	BOOL InitializeOpenGL();	//Initialize OpenGL
	BOOL SetupPixelFormat();	//Set up the Pixel Format
	void RenderScene();			//Render the Scene

	void calculateFramesPerSec();
	void PickObject(int x, int y);
	void AllocateID(CModel *mdl);
	void CreateTiles();
	

	// OBJECTS MAIN FUNCTIONS
	void DrawTiles();
	
	// SCENE MAIN FUNCTIONS
	bool SaveScene(char *filename);
	bool LoadScene(char *filename);
	void DestroyScene();
	// SCENE MAIN FUNCTIONS

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKillFocus(CWnd* pNewWnd);

	//{{AFX_MSG(CChildView)
	afx_msg void OnNewScene();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileResetscene();
	afx_msg void OnFileLoad();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__47020E0B_A6BF_4DC6_81A5_BBEB3415FFE9__INCLUDED_)
