// DlgMatrix.cpp : implementation file
//

#include "stdafx.h"
#include "OpenGLApp.h"
#include "DlgMatrix.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMatrix dialog


CDlgMatrix::CDlgMatrix(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgMatrix::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMatrix)
	m_PosX = 0.0f;
	m_PosY = 0.0f;
	m_PosZ = 0.0f;
	m_RotX = 0.0f;
	m_RotY = 0.0f;
	m_RotZ = 0.0f;
	m_ScaleX = 0.0f;
	m_ScaleY = 0.0f;
	m_ScaleZ = 0.0f;
	m_a = 0.0f;
	//}}AFX_DATA_INIT
	curMatrix = NULL;
}


void CDlgMatrix::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMatrix)
	DDX_Text(pDX, IDC_POSX, m_PosX);
	DDX_Text(pDX, IDC_POSY, m_PosY);
	DDX_Text(pDX, IDC_POSZ, m_PosZ);
	DDX_Text(pDX, IDC_ROTX, m_RotX);
	DDX_Text(pDX, IDC_ROTY, m_RotY);
	DDX_Text(pDX, IDC_ROTZ, m_RotZ);
	DDX_Text(pDX, IDC_SCX, m_ScaleX);
	DDX_Text(pDX, IDC_SCY, m_ScaleY);
	DDX_Text(pDX, IDC_SCZ, m_ScaleZ);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgMatrix, CDialog)
	//{{AFX_MSG_MAP(CDlgMatrix)
	ON_EN_KILLFOCUS(IDC_POSX, OnKillfocusPosx)
	ON_EN_KILLFOCUS(IDC_POSY, OnKillfocusPosy)
	ON_EN_KILLFOCUS(IDC_POSZ, OnKillfocusPosz)
	ON_EN_KILLFOCUS(IDC_ROTX, OnKillfocusRotx)
	ON_EN_KILLFOCUS(IDC_ROTY, OnKillfocusRoty)
	ON_EN_KILLFOCUS(IDC_ROTZ, OnKillfocusRotz)
	ON_EN_KILLFOCUS(IDC_SCX, OnKillfocusScx)
	ON_EN_KILLFOCUS(IDC_SCY, OnKillfocusScy)
	ON_EN_KILLFOCUS(IDC_SCZ, OnKillfocusScz)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMatrix message handlers

void CDlgMatrix::SetMatrix(CMatrix *mat)
{
	if(mat !=NULL)
	{
		curMatrix = mat;

		char string[16] = "";


		m_PosX = curMatrix->m_pos.x;
		m_PosY = curMatrix->m_pos.y;
		m_PosZ = curMatrix->m_pos.z;

		m_RotX = curMatrix->m_rot.x;
		m_RotY = curMatrix->m_rot.y;
		m_RotZ = curMatrix->m_rot.z;
		
		m_ScaleX = curMatrix->m_scale.x;
		m_ScaleY = curMatrix->m_scale.y;
		m_ScaleZ = curMatrix->m_scale.z;

		if(GetSafeHwnd())
			UpdateData(FALSE);
	}

}

void CDlgMatrix::UpdateMatrix()
{
	if(curMatrix !=NULL)
	{
		UpdateData(TRUE);
		CString txt;

		curMatrix->SetTranslation(CVector(m_PosX, m_PosY, m_PosZ));
		curMatrix->RotateDegrees(m_RotX, m_RotY, m_RotZ);
		curMatrix->Scale(m_ScaleX, m_ScaleY, m_ScaleZ);
		//SetMatrix(curMatrix);
	}
}

void CDlgMatrix::OnKillfocusPosx() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusPosy() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusPosz() 
{
	UpdateMatrix();	
}

void CDlgMatrix::OnKillfocusRotx() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusRoty() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusRotz() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusScx() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusScy() 
{
	UpdateMatrix();
}

void CDlgMatrix::OnKillfocusScz() 
{
	UpdateMatrix();
}
