// MapProp.cpp : implementation file
//

#include "stdafx.h"
#include "OpenGLApp.h"
#include "MapProp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapProp dialog


CMapProp::CMapProp(CWnd* pParent /*=NULL*/)
	: CDialog(CMapProp::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapProp)
	//}}AFX_DATA_INIT
}


void CMapProp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapProp)
	DDX_Control(pDX, IDC_TSY, m_TSY);
	DDX_Control(pDX, IDC_TSX, m_TSX);
	DDX_Control(pDX, IDC_MSY, m_MSY);
	DDX_Control(pDX, IDC_MSX, m_MSX);
	DDX_Control(pDX, IDC_TILEYSIZE, m_TileYSize);
	DDX_Control(pDX, IDC_TILEXSIZE, m_TileXSize);
	DDX_Control(pDX, IDC_MAPXSIZE, m_MapXSize);
	DDX_Control(pDX, IDC_MAPYSIZE, m_MapYSize);
	
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapProp, CDialog)
	//{{AFX_MSG_MAP(CMapProp)
	ON_WM_HSCROLL()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapProp message handlers



BOOL CMapProp::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_MapXSize.SetRange(5, 200, FALSE); 	
	m_MapYSize.SetRange(5, 200, FALSE); 	
	m_TileXSize.SetRange(5, 30, FALSE); 	
	m_TileYSize.SetRange(5, 30, FALSE); 	

	m_MapXSize.SetPos(10);	
	m_MapYSize.SetPos(10);
	m_TileXSize.SetPos(10);
	m_TileYSize.SetPos(10);	

	m_MapXSize.SetPageSize(5);
	m_MapYSize.SetPageSize(5);
	m_TileXSize.SetPageSize(5);
	m_TileYSize.SetPageSize(5);

	UpdateData(TRUE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMapProp::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	char txt[255] = "";

	if(((CSliderCtrl *)pScrollBar) == &m_MapXSize)
	{
		sprintf(txt, "%s %d", "Map X Size", m_MapXSize.GetPos());
		m_MSX.SetWindowText(txt); 
	}

	if(((CSliderCtrl *)pScrollBar) == &m_MapYSize)
	{
		sprintf(txt, "%s %d", "Map Y Size", m_MapYSize.GetPos());
		m_MSY.SetWindowText(txt); 
	}

	if(((CSliderCtrl *)pScrollBar) == &m_TileXSize)
	{
		sprintf(txt, "%s %d", "Tile X Size", m_TileXSize.GetPos());
		m_TSX.SetWindowText(txt); 
	}

	if(((CSliderCtrl *)pScrollBar) == &m_TileYSize)
	{
		sprintf(txt, "%s %d", "Tile Y Size", m_TileYSize.GetPos());
		m_TSY.SetWindowText(txt); 
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CMapProp::OnOK() 
{
	DWORD w, l;
	w = MAKEWPARAM( m_MapXSize.GetPos(), m_MapYSize.GetPos() );
	l = MAKELPARAM( m_TileXSize.GetPos(), m_TileYSize.GetPos() );
	pParent->SendMessage(MSG_CREATEMAP, w, l);
	
	ShowWindow(SW_HIDE);
	CDialog::OnOK();
}
