// sdindv.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "OpenGLApp.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLApp

BEGIN_MESSAGE_MAP(COpenGLApp, CWinApp)
	//{{AFX_MSG_MAP(COpenGLApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLApp construction

COpenGLApp::COpenGLApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_lCurTime = 0;             
	m_dwTimeCount = 8;   
	m_lPerfCounter = 0;       
	m_bPerFlag = FALSE;    
	m_lNextTime = 0;    
	m_lLastTime = 0;	 
	m_dTimeElapsed = 0.0;	 
	m_dTimeScale = 0.0;		
	m_lFramesPerSecond = 90;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only COpenGLApp object

COpenGLApp theApp;

/////////////////////////////////////////////////////////////////////////////
// COpenGLApp initialization

BOOL COpenGLApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));


	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);




	// The one and only window has been initialized, so show and update it.
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLApp message handlers





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void COpenGLApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLApp message handlers

int COpenGLApp::Run() 
{
	if (!m_pMainWnd)
		AfxPostQuitMessage(0);

	MSG msg;
	CMainFrame* pFrame = STATIC_DOWNCAST ( CMainFrame, m_pMainWnd );
	
	if ( QueryPerformanceFrequency ( ( LARGE_INTEGER *) &m_lPerfCounter ) ) { 

		// yes, set m_dwTimeCount and timer choice flag 
		m_bPerFlag = TRUE;
		m_dwTimeCount = unsigned long(m_lPerfCounter / m_lFramesPerSecond);
		QueryPerformanceCounter ( ( LARGE_INTEGER * ) &m_lNextTime ); 
		m_dTimeScale = 1.0 / m_lPerfCounter;
	} else  { 
		// no performance counter, read in using timeGetTime 

		m_lNextTime = timeGetTime (); 
		m_dTimeScale = 0.001;
	} 
	// save time of last frame

	m_lLastTime = m_lNextTime;

	while ( TRUE ) {
		//see if there is a message waiting

		if ( ::PeekMessage ( &msg, NULL, 0, 0, PM_NOREMOVE ) ) { 
			do //if there is pump all waiting
			{
				if ( !PumpMessage () )
					return ExitInstance ();
			} while ( ::PeekMessage ( &msg, NULL, 0, 0, PM_NOREMOVE ) );
		} else {

			// use the appropriate method to get time 
			// and calculate elapsed time since last frame

			if ( m_bPerFlag ) {
				QueryPerformanceCounter ( ( LARGE_INTEGER * ) &m_lCurTime );	
			} else {
				m_lCurTime=timeGetTime (); 
			}

			// is it time to render the frame? 

			if ( m_lCurTime > m_lNextTime ) { 

				// calculate elapsed time

				m_dTimeElapsed = ( m_lCurTime - m_lLastTime ) * m_dTimeScale;
				

				// save frame time

				m_lLastTime = m_lCurTime;
				
				// yes, render the frame 

				if ( !pFrame->m_bAppIsActive )
					WaitMessage();
				else
					pFrame->Render();

				// set time for next frame 

				m_lNextTime = m_lCurTime + m_dwTimeCount;
				char tmp[16] = "";
				sprintf(tmp, "%f", m_dTimeElapsed);
				pFrame->SetWindowText(tmp);
			} // end if

		} // end if else

	} // end while
	return msg.wParam;

}

