#include <mmsystem.h>

#ifndef TIMER_H
#define TIMER_H

class CTimer
{

	public:
		//	Timer resolution
		float m_fResolution;

	private:
		//	Time frequency
		__int64 m_wFrequency;

		//	Performance counter timer variables for start times
		__int64 m_wTimerStart;

		//	Using performance counter timer or multimedia timer?
		bool m_bUsePerformanceCounter;

		//	How many times the timer has been paused successively
		int m_iPauseCount;

		//	When the timer was paused
		double m_fPauseTime;

	public:
		/*	Constructor. */
		CTimer();

		/*	Reset the timer to zero. */
		void reset();

		/*	Retrieve the time in milliseconds since the timer started. */
		double getTime();

		double getAbsoluteTime();
		/*	Pause this timer. */
		virtual void pause();

		/*	Unpause this timer. */
		virtual void unpause();
};

#endif	// ndef TIMER_H
